[BITS 32]

SYS_EXIT_NR	equ 1
SYS_READ_NR	equ 3
SYS_WRITE_NR	equ 4
SYS_OPEN_NR	equ 5
SYS_CLOSE_NR	equ 6

section .text

global sys_exit
global sys_read
global sys_write
global sys_open
global sys_close

sys_exit:
	push ebx
	mov eax, SYS_EXIT_NR
	mov ebx, [esp + 8]     ;; status

	int 0x80
	pop ebx
	ret

sys_open:
	push ebx
	mov eax, SYS_OPEN_NR
	mov ebx, [esp + 8]     ;; file name
	mov ecx, [esp + 12]    ;; flags
	mov edx, [esp + 16]    ;; mode

	int 0x80
	pop ebx
	ret


sys_read:
	push ebx
	mov eax, SYS_READ_NR
	mov ebx, [esp + 8]     ;; file descriptor
	mov ecx, [esp + 12]    ;; buffer
	mov edx, [esp + 16]    ;; size

	int 0x80
	pop ebx
	ret

sys_write:
	push ebx
	mov eax, SYS_WRITE_NR
	mov ebx, [esp + 8]     ;; file descriptor
	mov ecx, [esp + 12]    ;; buffer
	mov edx, [esp + 16]    ;; size

	int 0x80
	pop ebx
	ret

sys_close:
	push ebx
	mov eax, SYS_EXIT_NR
	mov ebx, [esp + 8]     ;; file descriptor
	int 0x80
	pop ebx
	ret
