#ifndef STDIO_H
#define STDIO_H

#include "stdlib.h"

#define EOF 	(-1)
#define FILE	struct _stdio_file

#define stdin (&_stdin)
#define stdout (&_stdout)

#define _STDIO_OUTBUF_SIZE      (4096)
#define _STDIO_INBUF_SIZE       (4096)

struct _stdio_file {
	int fd;
	unsigned int outbuf_size;
	unsigned int inbuf_size;
	unsigned int inbuf_idx;
	int eof;
	char outbuf[_STDIO_OUTBUF_SIZE];
	char inbuf[_STDIO_INBUF_SIZE];
};

extern struct _stdio_file _stdin;
extern struct _stdio_file _stdout;

FILE *fopen(const char *path, const char *mode);
int fclose(FILE *stream);

int printf(const char *fmt, ...);
int fprintf(FILE *stream, const char *fmt, ...);
int puts(char *s);
int putchar(int c);
size_t fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);

int getc(FILE *f);
int getchar();
char *fgets(char *s, int size, FILE *stream);
size_t fread(void *ptr, size_t size, size_t nmemb, FILE *stream);

#endif
