[BITS 32]

SYS_EXIT_NR	  equ 1
SYS_READ_NR	  equ 3
SYS_WRITE_NR	  equ 4
SYS_OPEN_NR	  equ 5
SYS_CLOSE_NR	  equ 6
SYS_EXECVE_NR	  equ 11
SYS_BRK_NR	  equ 45
SYS_TRUNCATE_NR   equ 92

section .text

global sys_exit
global sys_read
global sys_write
global sys_open
global sys_close
global sys_execve
global sys_brk
global sys_truncate

sys_exit:
	push ebx
	mov eax, SYS_EXIT_NR
	mov ebx, [esp + 8]     ;; status

	int 0x80
	pop ebx
	ret

sys_open:
	push ebx
	mov eax, SYS_OPEN_NR
	mov ebx, [esp + 8]     ;; file name
	mov ecx, [esp + 12]    ;; flags
	mov edx, [esp + 16]    ;; mode

	int 0x80
	pop ebx
	ret


sys_read:
	push ebx
	mov eax, SYS_READ_NR
	mov ebx, [esp + 8]     ;; file descriptor
	mov ecx, [esp + 12]    ;; buffer
	mov edx, [esp + 16]    ;; size

	int 0x80
	pop ebx
	ret

sys_write:
	push ebx
	mov eax, SYS_WRITE_NR
	mov ebx, [esp + 8]     ;; file descriptor
	mov ecx, [esp + 12]    ;; buffer
	mov edx, [esp + 16]    ;; size

	int 0x80
	pop ebx
	ret

sys_close:
	push ebx
	mov eax, SYS_CLOSE_NR
	mov ebx, [esp + 8]     ;; file descriptor
	int 0x80
	pop ebx
	ret

sys_execve:
	push ebx
	mov eax, SYS_EXECVE_NR
	mov ebx, [esp + 8]     ;; path
	mov ecx, [esp + 12]    ;; arguments
	mov edx, [esp + 16]    ;; environment variables (not supported in POPS)

	int 0x80
	pop ebx
	ret

sys_brk:
	push ebx
	mov eax, SYS_BRK_NR
	mov ebx, [esp + 8]     ;; addr
	int 0x80
	pop ebx
	ret

sys_truncate:
	push ebx
	mov eax, SYS_TRUNCATE_NR
	mov ebx, [esp + 8]     ;; path
	mov ecx, [esp + 12]    ;; length
	int 0x80
	pop ebx
	ret
