#include "../util/util.h"
#include "../fs/mufs.h"
#include "../util/string.h"
#include "readelf.h"
#include "tasks.h"


#define USER_CODE_START         (0x00200000) /* adresa, kam je program nahran */
#define COMMAND_SHELL	        "/cosh"      /* cesta k programu s prikazovou radkou */
//#define COMMAND_SHELL	        "/hello02"      /* cesta k programu s prikazovou radkou */

struct task active_task;
extern struct mufs root_fs;

void task_exec_shell()
{
	task_exec(COMMAND_SHELL);
	kprint("Unable to execute: ");
	kprint(COMMAND_SHELL);
	kprint("\r\n");
}

void task_exec(char *path)
{
	Elf32_Ehdr ehdr;
	Elf32_Phdr phdr;

	struct mufs_fd *f = mufs_file_open(&root_fs, path, 0);
	int status = readelf_file_header(f, &ehdr);
	if (status == EOK) {
		active_task.min_brk = 0;
		for (int i = 0; i < ehdr.e_phnum; i++) {
			readelf_program_header(f, i, &ehdr, &phdr);
			mufs_file_seek(f, phdr.p_offset, SEEK_SET);

			if (phdr.p_type != PT_LOAD) continue;

			if (phdr.p_vaddr < USER_CODE_START) {
				kprint("Attempt to corrupt kernel memory\r\n");
				while (1);
			}

			memset((void *) phdr.p_vaddr, 0x00, phdr.p_memsz);
			mufs_file_read(f, (unsigned char *) phdr.p_vaddr, phdr.p_filesz);
			
			if (phdr.p_vaddr + phdr.p_memsz > active_task.min_brk) {
				active_task.min_brk = phdr.p_vaddr + phdr.p_memsz;
			}
		}
		active_task.cur_brk = active_task.min_brk;


		/* prepnuti do ring3 */
		jumpto_task(ehdr.e_entry);
		while (1);

	} else {
		kprint("Invalid file: ");
		kprint(path);
		kprint("\r\n");
	}
	mufs_file_close(f);

}

void task_scheduler()
{
	kprint("Starting scheduler...\r\n");
	while (1) {
		task_exec_shell();
	}
}
